src/Entity/Ad.php
<?php

namespace App\Entity;

use ApiPlatform\Core\Annotation\ApiResource;
use App\Repository\AdRepository;
use Cocur\Slugify\Slugify;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass=AdRepository::class)
 *
 * @ORM\HasLifecycleCallbacks
 * @UniqueEntity(
 *  fields={"title"},
 *  message="Une autre annonce possède déjà ce titre, merci de le modifier"
 * )
 * @ApiResource(
 * normalizationContext={
 *    "groups"={"ads_read"}
 *   },
 * collectionOperations={"GET", "POST"},
 * itemOperations={"GET", "PUT", "DELETE"},
 * attributes={
 *    "pagination_enabled"=true,
 *    "pagination_items_per_page"=15,
 *    "pagination_client_enabled"=true,
 *    "pagination_client_items_per_page"=true,
 *    "pagination_items_per_page_parameter_name"="count",
 *   }
 * )
 */
class Ad
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     * @Groups({"ads_read","users_read"})
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=50)
     * @Groups({"ads_read","users_read"})
     */
    private $title;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Length(min=10, max=255, minMessage="Le titre doit faire plus de 10 caractères !",
     * maxMessage="Le titre ne peut pas faire plus de plus de 255 caractères !")
     * @Groups({"ads_read"})
     */
    private $slug;

    /**
     * @ORM\Column(type="float")
     * @Groups({"ads_read"})
     */
    private $price;

    /**
     * @ORM\Column(type="text")
     * @Assert\Length(min=100, max=255, minMessage="Votre description doit faire plus de 100 caractères !")
     * @Groups({"ads_read"})
     */
    private $introduction;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Url()
     * @Groups({"ads_read"})
     */
    private $coverImage;

    /**
     * @ORM\OneToMany(targetEntity=Image::class, mappedBy="ad", orphanRemoval=true)
     * @Assert\Valid()
     * @Groups({"ads_read"})
     */
    private $images;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="ads")
     * @ORM\JoinColumn(nullable=false)
     * @Groups({"ads_read"})
     */
    private $author;

    /**
     * @ORM\OneToMany(targetEntity=Booking::class, mappedBy="ad")
     * @Groups({"ads_read"})
     */
    private $bookings;

    /**
     * @ORM\OneToMany(targetEntity=Comment::class, mappedBy="ad", orphanRemoval=true)
     * @Groups({"ads_read"})
     */
    private $comments;

    public function __construct()
    {
        $this->images = new ArrayCollection();
        $this->bookings = new ArrayCollection();
        $this->comments = new ArrayCollection();
    }

    /**
     * Permet de récupérer le commentaire d'une auteur par rapport à une annonce.
     *
     * @return Comment|null
     */
    public function getCommentFromAuthor(User $author)
    {
        foreach ($this->comments as $comment) {
            if ($comment->getAuthor() === $author) {
                return $comment;
            }
        }

        return null;
    }

    /**
     * Permet de calculer la moyenne pour les notes des annonces via les commentaires.
     *
     * @return float
     */
    public function getAvgRatings()
    {
        //calculer la somme des notations
        $sum = array_reduce($this->comments->toArray(), function ($total, $comment) {
            return $total + $comment->getRating();
        }, 0);
        //obtenir la moyenne
        if (count($this->comments) > 0) {
            return $sum / count($this->comments);
        }

        return 0;
    }

    /**
     * Cette fonction permet d'obtenir un tableau des jours indisponible.
     *
     * @return array un tableau d'objet dateTime représentant les jours d'occupation du produit
     */
    public function getNotAvailableDays()
    {
        $notAvailableDays = [];

        foreach ($this->bookings as $booking) {
            //calcul des jours qui se trouve entre la date de debut et de fin
            $result = range($booking->getStartDate()->getTimestamp(),
                            $booking->getEndDate()->getTimestamp(),
                            24 * 60 * 60
            );

            $days = array_map(function ($dayTimestamp) {
                return new \DateTime(date('Y-m-d', $dayTimestamp));
            }, $result);

            $notAvailableDays = array_merge($notAvailableDays, $days);
        }

        return $notAvailableDays;
    }

    /**
     * Permet d'initialiser le Slug.
     *
     * @ORM\PrePersist
     * @ORM\PreUpdate
     *
     * @return void
     */
    public function initializeSlug()
    {
        if (empty($this->slug)) {
            $slugify = new Slugify();
            $this->slug = $slugify->slugify($this->title);
        }
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    public function getPrice(): ?float
    {
        return $this->price;
    }

    public function setPrice(float $price): self
    {
        $this->price = $price;

        return $this;
    }

    public function getIntroduction(): ?string
    {
        return $this->introduction;
    }

    public function setIntroduction(string $introduction): self
    {
        $this->introduction = $introduction;

        return $this;
    }

    public function getCoverImage(): ?string
    {
        return $this->coverImage;
    }

    public function setCoverImage(string $coverImage): self
    {
        $this->coverImage = $coverImage;

        return $this;
    }

    /**
     * @return Collection|Image[]
     */
    public function getImages(): Collection
    {
        return $this->images;
    }

    public function addImage(Image $image): self
    {
        if (!$this->images->contains($image)) {
            $this->images[] = $image;
            $image->setAd($this);
        }

        return $this;
    }

    public function removeImage(Image $image): self
    {
        if ($this->images->removeElement($image)) {
            // set the owning side to null (unless already changed)
            if ($image->getAd() === $this) {
                $image->setAd(null);
            }
        }

        return $this;
    }

    public function getAuthor(): ?User
    {
        return $this->author;
    }

    public function setAuthor(?User $author): self
    {
        $this->author = $author;

        return $this;
    }

    /**
     * @return Collection|Booking[]
     */
    public function getBookings(): Collection
    {
        return $this->bookings;
    }

    public function addBooking(Booking $booking): self
    {
        if (!$this->bookings->contains($booking)) {
            $this->bookings[] = $booking;
            $booking->setAd($this);
        }

        return $this;
    }

    public function removeBooking(Booking $booking): self
    {
        if ($this->bookings->removeElement($booking)) {
            // set the owning side to null (unless already changed)
            if ($booking->getAd() === $this) {
                $booking->setAd(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Comment[]
     */
    public function getComments(): Collection
    {
        return $this->comments;
    }

    public function addComment(Comment $comment): self
    {
        if (!$this->comments->contains($comment)) {
            $this->comments[] = $comment;
            $comment->setAd($this);
        }

        return $this;
    }

    public function removeComment(Comment $comment): self
    {
        if ($this->comments->removeElement($comment)) {
            // set the owning side to null (unless already changed)
            if ($comment->getAd() === $this) {
                $comment->setAd(null);
            }
        }

        return $this;
    }
}

src/Entity/User.php
<?php

namespace App\Entity;

use App\Repository\UserRepository;
use Cocur\Slugify\Slugify;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass=UserRepository::class)
 * @ORM\HasLifecycleCallbacks()
 * @UniqueEntity(
 *  fields={"email"},
 * message="un autre utilisateur s'est déjà inscrit avec cette adresse email, merci de la modifier"
 * )
 */
class User implements UserInterface
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     * @Groups({"users_read"})
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="vous devez renseigner votre prénom")
     * @Groups({"users_read"})
     */
    private $firstName;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="vous devez renseigner votre nom")
     * @Groups({"users_read"})
     */
    private $lastName;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Email(message="Veuillez renseigner un email valide !")
     * @Groups({"users_read"})
     */
    private $email;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @Groups({"users_read"})
     */
    private $picture;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $hash;

    /**
     * @Assert\EqualTo(propertyPath="hash",message="Vous n'avez pas correctement confirmé votre mot de passe")
     */
    public $passwordConfirm;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Length(min=10,minMessage="Votre introduction doit faire au moins 10 caractère")
     * @Groups({"users_read"})
     */
    private $introduction;

    /**
     * @ORM\Column(type="text")
     * @Assert\Length(min=100,minMessage="Votre description doit faire au moins 100 caractère")
     * @Groups({"users_read"})
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $slug;

    /**
     * @ORM\OneToMany(targetEntity=Ad::class, mappedBy="author")
     * @Groups({"users_read"})
     */
    private $ads;

    /**
     * @ORM\ManyToMany(targetEntity=Role::class, mappedBy="users")
     */
    private $userRoles;

    /**
     * @ORM\OneToMany(targetEntity=Booking::class, mappedBy="booker")
     * @Groups({"users_read"})
     */
    private $bookings;

    /**
     * @ORM\OneToMany(targetEntity=Comment::class, mappedBy="author", orphanRemoval=true)
     * @Groups({"users_read"})
     */
    private $comments;

    public function getFullName()
    {
        return "{$this->firstName} {$this->lastName}";
    }

    /**
     * Permet d'initialiser le Slug.
     *
     * @ORM\PrePersist
     * @ORM\PreUpdate
     *
     * @return void
     */
    public function initializeSlug()
    {
        if (empty($this->slug)) {
            $slugify = new Slugify();
            $this->slug = $slugify->slugify($this->firstName.' '.$this->lastName);
        }
    }

    public function __construct()
    {
        $this->ads = new ArrayCollection();
        $this->userRoles = new ArrayCollection();
        $this->bookings = new ArrayCollection();
        $this->comments = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFirstName(): ?string
    {
        return $this->firstName;
    }

    public function setFirstName(string $firstName): self
    {
        $this->firstName = $firstName;

        return $this;
    }

    public function getLastName(): ?string
    {
        return $this->lastName;
    }

    public function setLastName(string $lastName): self
    {
        $this->lastName = $lastName;

        return $this;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    public function getPicture(): ?string
    {
        return $this->picture;
    }

    public function setPicture(?string $picture): self
    {
        $this->picture = $picture;

        return $this;
    }

    public function getHash(): ?string
    {
        return $this->hash;
    }

    public function setHash(string $hash): self
    {
        $this->hash = $hash;

        return $this;
    }

    public function getIntroduction(): ?string
    {
        return $this->introduction;
    }

    public function setIntroduction(string $introduction): self
    {
        $this->introduction = $introduction;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    /**
     * Undocumented function.
     *
     * @return array
     */
    public function getRoles()
    {
        $roles = $this->userRoles->map(function ($role) {
            return $role->getTitle();
        })->toArray();
        $roles[] = 'ROLE_USER';

        return $roles;
    }

    /**
     * Undocumented function.
     *
     * @return void
     */
    public function getPassword()
    {
        return $this->hash;
    }

    public function getUsername()
    {
        return $this->email;
    }

    public function getSalt()
    {
    }

    public function eraseCredentials()
    {
    }

    /**
     * @return Collection|Ad[]
     */
    public function getAds(): Collection
    {
        return $this->ads;
    }

    public function addAd(Ad $ad): self
    {
        if (!$this->ads->contains($ad)) {
            $this->ads[] = $ad;
            $ad->setAuthor($this);
        }

        return $this;
    }

    public function removeAd(Ad $ad): self
    {
        if ($this->ads->removeElement($ad)) {
            // set the owning side to null (unless already changed)
            if ($ad->getAuthor() === $this) {
                $ad->setAuthor(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Role[]
     */
    public function getUserRoles(): Collection
    {
        return $this->userRoles;
    }

    public function addUserRole(Role $userRole): self
    {
        if (!$this->userRoles->contains($userRole)) {
            $this->userRoles[] = $userRole;
            $userRole->addUser($this);
        }

        return $this;
    }

    public function removeUserRole(Role $userRole): self
    {
        if ($this->userRoles->removeElement($userRole)) {
            $userRole->removeUser($this);
        }

        return $this;
    }

    /**
     * @return Collection|Booking[]
     */
    public function getBookings(): Collection
    {
        return $this->bookings;
    }

    public function addBooking(Booking $booking): self
    {
        if (!$this->bookings->contains($booking)) {
            $this->bookings[] = $booking;
            $booking->setBooker($this);
        }

        return $this;
    }

    public function removeBooking(Booking $booking): self
    {
        if ($this->bookings->removeElement($booking)) {
            // set the owning side to null (unless already changed)
            if ($booking->getBooker() === $this) {
                $booking->setBooker(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Comment[]
     */
    public function getComments(): Collection
    {
        return $this->comments;
    }

    public function addComment(Comment $comment): self
    {
        if (!$this->comments->contains($comment)) {
            $this->comments[] = $comment;
            $comment->setAuthor($this);
        }

        return $this;
    }

    public function removeComment(Comment $comment): self
    {
        if ($this->comments->removeElement($comment)) {
            // set the owning side to null (unless already changed)
            if ($comment->getAuthor() === $this) {
                $comment->setAuthor(null);
            }
        }

        return $this;
    }
}

templates/ad/_ad.html.twig
{% set url = path('ads_show', {'slug': ad.slug}) %}
<div class="col-md-4">
    <div class="card bgAds mb-3 cardHeight">
        <div class="card-header text-center">
            <strong>{{ ad.price | number_format(2, ',', ' ') }}&euro; / jour</strong> <br>
            {% if ad.comments|length > 0 %}
                {% include 'partials/rating.html.twig' with {'rating':ad.avgRatings}%}
            {% else %}
                <small>Pas encore noté</small>
            {% endif %}
        </div>
        <a href="{{url}}">
            <img src="{{ ad.coverImage }}" alt="Image de l'appartement" style="height: 200px; width: 100%; display: block;"/>
        </a>
        <div class="card-body">
            <h4 class="card-title cob tac">
                <a href="{{url}}">
                    {{ ad.title }}
                </a>
            </h4>
            <p class="card-text cob">
                {{ ad.introduction | truncate(125) | raw }}
            </p>
            <a href="{{url}}" class="btn btn-light float-right">
                En savoir plus !
            </a>
            {% if app.user and app.user == ad.author %}
                <a href="{{path('ads_edit', {'slug':ad.slug})}}" class="btn btn-secondary">Modifier l'annonce !</a>
            {% endif %}
        </div>
    </div>
</div>

templates/ad/_adHome.html.twig
{% set url = path('ads_show', {'slug': ad.slug}) %}
<div class="item service-item">
    <div class="testimonial-content">
        <ul class="stars">
            <strong>{{ ad.price | number_format(2, ',', ' ') }}&euro; / jour</strong> <br>
            {% if ad.comments|length > 0 %}
                {% include 'partials/rating.html.twig' with {'rating':ad.avgRatings}%}
            {% else %}
                <small>Pas encore noté !</small>
            {% endif %}
        </ul>
        <a href="{{url}}">
            <img src="{{ ad.coverImage }}" alt="Image du produit" class="img-card"/>
        </a>
        <h4>
            <a href="{{url}}" class="color-white">{{ ad.title }}</a>
        </h4>
        <p>{{ ad.introduction | truncate(150) | raw }}</p>
        <a href="{{url}}" class="btn btn-dark">
            En savoir plus !
        </a>
        {% if app.user and app.user == ad.author %}
            <a href="{{path('ads_edit', {'slug':ad.slug})}}" class="btn btn-info">Modifier l'annonce !</a>
        {% endif %}
    </div>
</div>

templates/ad/_collection.html.twig
{% block _ad_images_widget %}
    <p>Ici, vous pouvez ajouter vos propres images !</p>
    
    {{ form_widget(form) }}

    <input type="hidden" id="widgets-counter" value=""/>

    <div class="form-group">
        <button type="button" id="add-image" class="btn btn-primary">
            <i class="fas fa-plus"></i>
            Ajouter une image
        </button>
    </div>
{% endblock %}

{% block _ad_images_entry_row %}
    {{ form_widget(form) }}
{% endblock %}

{% block _ad_images_entry_widget %}
    <div class="form-group" id="block_{{id}}">
        <div class="row">
            <div class="col-10">
                <div class="row">
                    <div class="col">
                        {{ form_widget(form.url) }}
                        {{ form_errors(form.url) }}
                    </div>
                    <div class="col">
                        {{ form_widget(form.caption) }}
                        {{ form_errors(form.caption) }}
                    </div>
                </div>    
            </div>
            <div class="col-2">
                <button type="button" data-action="delete" data-target="#block_{{id}}" class="btn btn-danger">X</button>
            </div>
        </div>
    </div>
{% endblock %}

templates/ad/edit.html.twig
{% extends 'base.html.twig' %}

{% block header %}{% endblock %}
{% block title %}Edition d'une annonce !{% endblock %}

{% form_theme form 'ad/_collection.html.twig' %}

{% block body %}

<div class="container mat7">
    <h1>Modifier l'annonce : {{ ad.title }}</h1>

    {{ form_start(form) }}

    {{ form_widget(form) }}

    <button class="btn btn-primary" type="submit">Modifier</button>

    {{ form_end(form) }}

</div>

{% endblock %}


{% block javascripts %}
    <script src="/js/ad.js"></script>
{% endblock %}

templates/ad/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}
    Nos magnifiques annonces !
{% endblock %}
{% block body %}
<div class="container">
    <h1 class="maTmaB tac">Les annonces de nos clients</h1>
    <div class="row">
        {% for ad in ads %}
            {% include 'ad/_ad.html.twig' %}
        {% endfor %}
    </div>
{% endblock %}

templates/ad/new.html.twig
{% extends 'base.html.twig' %}

{% block title %} Création d'une annonce {% endblock %}

{% form_theme form _self %}

{% block body %}

<div class="container mat7">
    <h1 class="maTmaB tac">Créer une nouvelle annonce</h1>

    {{ form_start(form) }}
    <div class="row">
        <div class="alert alert-light">
            <h2>Informations générales</h2>
            <hr>
            {{ form_row(form.title) }}
            {{ form_row(form.slug) }}
            {{ form_row(form.price) }}
        </div>
        <div class="alert alert-light">
            <h2>Détails de l'annonce</h2>
            <hr>
            {{ form_row(form.introduction) }}
        </div>
        <div class="alert alert-light">
            <h2>Images de l'annonce</h2>
            <hr>
            {{ form_row(form.coverImage) }}
            {{ form_row(form.images) }}
        </div>
    </div>
    <div class="alert alert-secondary clearfix">
        <h2 class="tac alert-heading">Sauvegarder mon annonce</h2>
        <p>Vous êtes sur le point de créer votre annonce, nous sommes fier de vous !</p>
        <button class="btn btn-primary float-right" type="submit">
            <i class="fas fa-check"></i>
            Créer la nouvelle annonce
        </button>
    </div>
    {{ form_end(form) }}
</div>
{% endblock %}

{% block _ad_images_widget %}
    <p>Ici, vous pouvez ajouter vos propres images !</p>

    {{ form_widget(form) }}

    <div class="form-group">
        <button type="button" id="add-image" class="btn btn-primary">Ajouter une image</button>
    </div>

{% endblock %} 


{% block javascripts %}
    <script src="/js/ad.js"></script>
{% endblock %}

templates/ad/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}
    {{ad.title}}
{% endblock %}

{% block body %}
    <!-- FIXE ME au niveau du style le mettre dans le fichier app.css -->
    <div class="mat7" style="background-image:url('{{ad.coverImage}}');padding: 2em;background-size: cover;background-position: center center;">
        <div class="container">
            <h1 style="color: white;text-shadow: 3px 3px 3px rgba(0,0,0,0.5);">{{ad.title}}</h1>
            <p class="h2" style="color: white;text-shadow: 3px 3px 3px rgba(0,0,0,0.5);">
                <strong>Pour <strong>{{ad.price | number_format(2, ',', ' ') }}&euro;</strong> par jour.
            </p>
            <a href="{{ path('booking_create', {'slug':ad.slug}) }}" class="btn btn-primary">Réserver !</a>
            {% if app.user and app.user == ad.author %}
                <a href="{{path('ads_edit', {'slug':ad.slug})}}" class="btn btn-secondary">Modifier l'annonce !</a>
                <a href="{{path('ads_delete', {'slug':ad.slug})}}" class="btn btn-danger" onclick="return confirm(`Êtes vous sur de vouloir supprimer l'annonce: {{ad.title}}`)">Supprmier l'annonce !</a>
            {% endif %}
        </div> 
    </div>

    <div class="container">
        <div class="row">
            <div class="col-md-8 mb-3">
                {{ad.introduction | raw }}
                <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
                    <ol class="carousel-indicators">
                    {% for image in ad.images %}
                        <li data-target="#carouselExampleIndicators" data-slide-to="{{ loop.index0 }}" {% if loop.first %}class="active"{% endif %}></li>
                    {% endfor %}
                    </ol>
                    <div class="carousel-inner">
                    {% for image in ad.images %}
                        <div class="carousel-item {% if loop.first %}active{% endif %}">
                            <img class="d-block w-100" src="{{ image.url }}" alt="First slide">
                            <div class="carousel-caption d-none d-md-block">
                                <h5>{{ ad.title }}</h5>
                                <p>{{ image.caption }}</p>
                            </div>
                        </div>
                    {% endfor %}
                    </div>
                    <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
                        <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                        <span class="sr-only">Previous</span>
                    </a>
                    <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
                        <span class="carousel-control-next-icon" aria-hidden="true"></span>
                        <span class="sr-only">Next</span>
                    </a>
                </div>
                <hr>
                {% if ad.comments|length > 0 %}
                    <h2 class="tac mb-3">Commentaires de nos clients :</h2>

                    <div class="alert alert-info">
                        <h4 class="alert-heading text-center">
                            <div class="row align-items-center">
                                <div class="col">
                                    Note global donnée par nos clients
                                </div>
                                <div class="col">
                                    {% include 'partials/rating.html.twig' with {'rating':ad.avgRatings} %}
                                    <br>
                                    <small>(Calculée sur {{ad.comments|length}} avis)</small>
                                </div>
                            </div>
                        </h4>
                    </div>
                    {% for comment in ad.comments %}
                        <div class="bg-light mb-3 py-3 px-3">
                            <strong>{{ comment.author.firstName }}</strong> a dit :
                            <blockquote>
                                {{comment.content}}
                            </blockquote>
                            <strong>Note donnée :</strong>
                            {% include 'partials/rating.html.twig' with {'rating':comment.rating} %}
                        </div>
                    {% endfor %}
                {% else %}
                    <h2>Cette annonce n'a pas encore reçu de commentaires ...</h2>
                {% endif %}
            </div>
            <div class="col">
                {% set a = ad.author %}
                <div class="row">
                    <div class="col-3">
                        <a href="{{path('user_show', {'slug':a.slug})}}">
                            <img src="{{a.picture}}" class="avatar avatar-medium" alt="Avatar de {{a.fullName}}"/>
                        </a>
                    </div>
                    <div class="col">
                        <a href="{{path('user_show', {'slug':a.slug})}}">
                            <h3>{{a.fullName}}</h3>
                        </a>
                        <span class="badge badge-primary">{{a.ads | length}} annonces</span>
                    </div>
                </div>
                {{ a.description | raw }}
            </div>
        </div>
    </div>

{% endblock %}